var fs = require('fs')
    , gm = require('gm');
module.exports = class MemeGenerator {

    /**
     * Creates a new meme generator, parsing the meme config file in
     */
    constructor(configFile) {

    }

    /**
     * Adds a new meme configuration to the supported set of memes
     * @param memeTemplate a new meme, as a JS object in the same format as the meme data file
     */
    addMemeTemplate(memeTemplate) {

    }


    /**
     * Checks that a request to generate a meme is valid, specifically:
     *      That the meme referenced is defined
     *      That the text blocks defined in the requested meme are all valid (exist) for that meme referenced
     *      That the referenced graphic file exists
     * @param meme meme object to check
     * @returns A string if there is an error, false if there is no error
     */
    validateMeme(meme) {
        return false;
    }

    /**
     * Given a meme configuration, generates the composite graphic (layering the text atop of the graphic)
     * A meme configuration references a "base meme" template --- the template defines where text will be positioned
     * and its font/stroke/color; the meme configuration specifies which template to use and what text to put in the
     * different positions. The meme is written directly out to the image file specified in the configuration.
     *
     * Note that this function returns a PROMISE representing the generation of the image, as generating the image is an
     * async operation.
     *
     * @param meme configuration for the meme to generate
     * @returns Promise that is completed when the image is successfully written out to disk
     */
    generateMeme(meme) {
        return new Promise(function (resolve, reject) {
    	});
    }
}
